<?php
class TabulPHP{
	static $BS1;
	static $BS2;
	static $highlite = false;
	private static function sv($t){
		$fa = array('{','}','<','>');
		$ra = array(self::$BS1,self::$BS2,'&lt;','&gt;');
		return str_replace($fa,$ra,$t);
	}

	public static function tab($str,$count){
		$ts = "\t";
		if (!self::$highlite) {
			$str = str_replace(array('<','>'),array('&lt;','&gt;'),$str);
			$ts = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
		}
		
		if ($count == 0) {
			return $str;
		}
		$t = '';
		for ($i = 0;$i<$count;$i++){
			$t .= $ts;
		}
		return $t.$str;
	}
	
	public static function tabulate($text,$highlite = false){
		self::$BS1 = "!!--".sha1(md5(microtime()).'1')."--!!";
		self::$BS2 = "!!--".sha1(md5(microtime()).'2')."--!!";
		self::$highlite = $highlite;
		$text = str_replace("\r",'',$text);
		$text = preg_replace("~[\"'](.*?)(\{|\})(.*?)[\"']~ie","self::sv('\\0')",$text);

		$text = preg_replace("~\ {1,}~i",' ',$text);
		$text = preg_replace("~\t{1,}~i",'',$text);
		$text = preg_replace("~\n{2,}~i","\n",$text);

		$tab = 0;
		$lines = explode("\n",$text);
		$rr = array();
		foreach ($lines as $line){
			$a = (strpos($line,'{') !== false) ? true : false;
			$b = (strpos($line,'}') !== false) ? true : false;

			if ($a && $b) {
				$tab--;
				$rr[] = self::tab($line,$tab);
			} elseif ($a && !$b){
				$rr[] = self::tab($line,$tab);
				$tab++;
			} elseif ($b && !$a){
				$tab--;
				$rr[] = self::tab($line,$tab);
			} else {
				$rr[] = self::tab($line,$tab);
			}

		}
		
		if ($highlite) {
			$strl = str_replace(array(self::$BS1,self::$BS2),array('{','}'),join("\r\n",$rr));
			return highlight_string($strl);
		} else {
			return str_replace(array(self::$BS1,self::$BS2),array('{','}'),join("<br />\r\n",$rr));
		}
		
	}

}